<template>
	<view class="page-wrap">
		<uni-card margin="0" :is-shadow="true">
			<u--form labelPosition="left" labelWidth="auto" labelAlign="center" :model="model">
				<u-form-item label="层级：" prop="LEVEL_SHOW" borderBottom>
					<u--input v-model="model.LEVEL_SHOW" border="none" slot="right" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="制定人：" prop="Nav_LiableUser.NAME" borderBottom>
					<u--input autoHeight v-model="model.Nav_LiableUser.NAME" border="none" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="执行时间：" prop="execTime" borderBottom>
					<u--input v-model="model.execTime" border="none" slot="right" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="辨识区域：" prop="Areas" borderBottom>
				</u-form-item>
				<u--textarea v-model="model.Areas" border="none" inputAlign="right" disabled></u--textarea>
				<view class="upload-title">附件</view>
				<full-upload v-model="model.Nav_Files" :listProp='listPropUpload'
					:listPropVal='listPropValUpload' :isShowBtn="false"></full-upload>
			</u--form>
		</uni-card>
		<u-sticky offset-top="20">
			<view class="sub-form">
				<view class="sub-form-wrap">
					<u--form labelPosition="left" labelWidth="auto" labelAlign="center" errorType="border-bottom"
						ref="sForm">
						<u-collapse :border="false" accordion>
							<uni-card style="margin-bottom: 16px;" margin="0" spacing="0" :is-shadow="false"
								v-for="(item, index) in model.Nav_Detail">
								<u-collapse-item
									:title="index + 1 + '. '+item.Nav_Area.NAME+' | '+ item.allIdentifyings">
									<u-form-item label="区域" prop="allUsers" borderBottom>
										<u--input disabled disabledColor="#fff" v-html="item.Nav_Area.NAME"
											border="none" slot="right"></u--input>
									</u-form-item>
									<u-form-item label="辨识人员" prop="allUsers" borderBottom>
										<u--input disabled disabledColor="#fff" v-html="item.allUsers" border="none"
											slot="right"></u--input>
									</u-form-item>
									<u-form-item label="记录人" prop="allUsers" borderBottom>
										<u--input disabled disabledColor="#fff" v-html="item.Nav_User.NAME"
											border="none" slot="right"></u--input>
									</u-form-item>
								</u-collapse-item>
							</uni-card>
						</u-collapse>
					</u--form>
				</view>
			</view>
		</u-sticky>
		<audit-process :show="showAudit" @close="handleCloseAudit" :dataSource="auditData" />
		<check-action v-if="isLoadOK && tableKey === '1'&&isAudit==='true' " :okApi="okApi" :refuseApi="refuseApi"
			:dataSource="$store.state.auditModel"></check-action>
		<view class="bottom-button">
			<button type="primary" class="bottom" v-if='isLoadOK&&tableKey==1&&!isAudit'
				@click="onTableBtnAgree">签到</button>
		</view>
	</view>
</template>

<script>
	import {
		initFilter,
		extendRule,
		extendInclude
	} from '../../../../utils/common'

	import {
		getRequest,
	} from '../../../../services/apply/FOServices/FOServices'
	import '../../../../utils/showMsg.js'
	import color from '../../../../uni_modules/uview-ui/libs/config/color'
	import config from '../../../../config/common'

	export default {
		data() {
			return {
				listPropUpload: ['TASK_ID'],
				listPropValUpload: [],
				model: {
					Nav_Request: "",
					Nav_LiableUser: ""
				},
				TaskID: "",
				tableKey: '0',
				isLoadOK: false,
				execTime: "",
				auditData: [],
				showAudit: false,
				orgId: uni.getStorageSync('orgId')
			}
		},
		onLoad(option) {
			this.model.ID = option.ID;
			this.TaskID = option.taskID;
			this.tableKey = option.tableKey ? option.tableKey : '0'
			this.isAudit = option.isAudit
			this.okApi = option.okApi
			this.refuseApi = option.refuseApi
			this.loadData()
		},
		methods: {
			loadData() {
				const json = initFilter(this.orgId, "", "CODE", 1)
				extendRule(json, 'ID', 1, this.model.ID);
				extendInclude(json, 'Nav_LiableUser');
				extendInclude(json, 'Nav_Files.Nav_ImgFile');
				extendInclude(json, 'Nav_Detail.Nav_Users.Nav_User');
				extendInclude(json, 'Nav_Detail.Nav_Identifyings.Nav_Identifying');
				extendInclude(json, 'Nav_Detail.Nav_User');
				extendInclude(json, 'Nav_Detail.Nav_Area');
				getRequest(json, "/HM/HazardTask/Get").then(res => {
					this.model = res
					let strUserName = '';
					let strAreas = '';
					if (res.Nav_Users && res.Nav_Users.length > 0) {
						for (let i = 0; i < res.Nav_Users.length; i++) {
							if (res.Nav_Users[i].DEAL_STATUS == 0) {
								strUserName += (strUserName.length > 0 ? " " : "") +
									"<text style='color:red'>" +
									res.Nav_Users[i].Nav_User.NAME + "</text>&nbsp;";
							} else {
								strUserName += (strUserName.length > 0 ? " " : "") + res.Nav_Users[
									i].Nav_User.NAME;
							}

						}
					}
					if (res.Nav_Detail && res.Nav_Detail.length > 0) {
						for (let i = 0; i < res.Nav_Detail.length; i++) {
							strAreas += (strAreas.length > 0 ? " " : "") + res.Nav_Detail[
								i].Nav_Area.NAME;
						}
					}
					this.model.LEVEL_SHOW = this.transLevel(this.model.LEVEL);
					this.model.execTime = uni.$u.timeFormat(this.model.START_TIME, 'yyyy-mm-dd') + '~' + uni.$u
						.timeFormat(this.model.END_TIME, 'yyyy-mm-dd');
					if (res.Nav_Detail && res.Nav_Detail.length > 0) {
						for (let i = 0; i < res.Nav_Detail.length; i++) {
							let strAllUsers = "";
							let strIdentifyings = "";
							for (let j = 0; j < res.Nav_Detail[i].Nav_Users.length; j++) {
								if (res.Nav_Detail[i].Nav_Users[j].DEAL_STATUS == 0) {
									strAllUsers += (strAllUsers.length > 0 ? " " : "") +
										"<text style='color:red'>&nbsp;" +
										res.Nav_Detail[i].Nav_Users[j].Nav_User.NAME + " </text>";
								} else {
									strAllUsers += (strAllUsers.length > 0 ? "&nbsp;" : "") + res.Nav_Detail[
										i].Nav_Users[j].Nav_User.NAME;
								}
								if (res.Nav_Detail[i].Nav_Identifyings[j]) {
									strIdentifyings += (strIdentifyings.length > 0 ? " " : "") + res.Nav_Detail[i]
										.Nav_Identifyings[j].Nav_Identifying.NAME;
								}

							}
							this.model.Nav_Detail[i].allUsers = strAllUsers;
							this.model.Nav_Detail[i].allIdentifyings = strIdentifyings;
						}
					}
					this.model.UserNames = strUserName;
					this.model.Areas = strAreas;
					this.isLoadOK = true
				})
			},
			onTableBtnAgree() {
				let json = {};
				json.ID = this.model.ID;
				json.TaskID = this.TaskID;
				getRequest(json, "/HM/HMHazardTask/UserSignin").then(res => {
					if (res) {
						uni.$showMsgFunc('操作成功!', () => {
							uni.navigateBack()
						}, 'success', 1000)
					}
				})
			},
			transLevel(level) {
				if (level == 0) {
					return '部门 ';
				}
				if (level == 1) {
					return '车间 ';
				}
				if (level == 2) {
					return '班组 ';
				}
				if (level == 3) {
					return '公司 ';
				}
			},
			loadAuditData() {
				const json = initFilter(this.orgId, this.model.ID, "CODE", 1)
				return new Promise((resolve, reject) => {
					getRequest(json, "/PF/Approve/GetApproveInfo").then(res => {
						if (res) {
							if (res && res[0].Nav_ApproveDetails.length > 0) {
								resolve(res)
							}
						} else {
							uni.showToast({
								title: '暂无审批数据',
								icon: 'none'
							})
						}
					}).catch(err => {
						reject(err)
					})
				})
			},
			handleCloseAudit() {
				this.showAudit = false
			},
			async onNavigationBarButtonTap() {
				const res = await this.loadAuditData()
				if (res) {
					this.auditData = res
					this.showAudit = true
				}
			}
		}
	}
</script>

<style>
	@import url("@/style/css/editTemplate.css");
</style>